module Basics
  def checkundef(x=nil, y=nil)
     rundef = Common.rundef
     window = Fig.window
     inclpoint = Fig.included_range
     range = get_range(window, inclpoint)
     if(x_setundef?(range))
	if(typearray(x))
	   Fig.inclpoint(x, rundef)
	elsif(x.is_a?(Float))
	   Fig.inclpoint([0.0, x], rundef)
	else
	   Fig.inclpoint([0.0, 1.0], rundef)
	end
     end
     if(y_setundef?(range))
	if(typearray(y))
	   Fig.inclpoint(rundef, y)
	elsif(x.is_a?(Float))
	   Fig.inclpoint(rundef, [0.0, y])
	else
	   Fig.inclpoint(rundef, [0.0, 1.0])
	end
     end
  end

  def x_setundef?(ary)
     rundef = Common.rundef
     for i in 0..1
	if(ary[i]==rundef)
	   return true
	end
     end
     false
  end

  private :x_setundef?

  def y_setundef?(ary)
     rundef = Common.rundef
     for i in 2..3
	if(ary[i]==rundef)
	   return true
	end
     end
     false
  end
  
  private :y_setundef?
  
  def get_range(window, incl)
     rundef = Common.rundef
     range = Array.new(4)
     window.each_index{|i|
	if(window[i] == rundef)
	   range[i] = incl[i]
	elsif(incl[i] == rundef)
	   range[i] = window[i]
	else
	   case i
	   when 0, 2
	      if(window[i] < incl[i])
		 range[i] = window[i]
	      else
		 range[i] = incl[i]
	      end
	   when 1, 3
	      if(window[i] < incl[i])
		 range[i] = incl[i]
	      else
		 range[i] = window[i]
	      end
	   end
	end
     }
     range
  end 
  
  private :get_range
  
  def typearray(obj)
     return (obj.is_a?(Array) || obj.is_a?(NArray))
  end
  
  module_function :get_range
  module_function :x_setundef?
  module_function :y_setundef?
  module_function :checkundef
  module_function :typearray
end

