#
# kihon8.rb

require "narray"
require "numru/advanceddcl"
include NumRu::AdvancedDCL
include NMath


xmin = 1.0
xmax = 100.0
ymin = 1.0
ymax = 100.0

def bplot

  nmax = 50
  x = NArray.sfloat(nmax)
  y = NArray.sfloat(nmax)

#-- ꎟ֐ ----
  x.indgen(2.0, 2.0)
  y = x

  Plot.draw(x, y)

#-- w֐ ----
  y = exp(0.05*x)

  Plot.draw(x, y, "linetype"=>2)

#-- ΐ֐ ----
  y = 20.0 * log(x)

  Plot.draw(x, y, "linetype"=>3)

#--  ----
  Text.draw(30.0, 40.0, '(30,40)', "charsize"=>0.02)

  Frame.pvpr(1)
end


#-- graph ---
Dev.open

Fig.lclip=true

Frame.new
#-- plW() ----
Fig.window=[xmin, xmax, ymin, ymax]
Fig.viewport=[0.1, 0.4, 0.6, 0.9]
Fig.transnum=1

bplot

#-- Бΐ(y)W(E) ----
Fig.viewport=[0.6, 0.9, 0.6, 0.9]
Fig.transnum=2

bplot

#-- Бΐ(x)W() ----
Fig.viewport=[0.1, 0.4, 0.1, 0.4]
Fig.transnum=3

bplot
      
#-- ΐW(E) ----
Fig.viewport=[0.6, 0.9, 0.1, 0.4]
Fig.transnum=4

bplot

Dev.close

