#
# step2.rb
#   $Id: step2.rb,v 1.1 2000/11/18 18:57:43 keiko Exp $
#

require "narray"
require "numru/advanceddcl"

include NumRu::AdvancedDCL
include NMath

nmax = 100
x = 0
y = 1

x = NArray.sfloat(nmax)
y = NArray.sfloat( nmax)

#-- data ----
iseed = 0
x[0] = 2*(rand(iseed)-0.5)
y[nmax-1] = x[0]

for i in 1..nmax-1
  x[i] = 2*(rand(iseed)-0.5)
  y[i-1] = x[i]
end

#-- graph ----
Dev.open
Frame.new

Fig.inclpoint(x, y)

Axis.title( 'X-TITLE', 'x-unit', 'Y-TITLE', 'y-unit' )
Axis.draw

cnt = nmax/4
st = 0
ed = cnt-1
Mark.markindex = 5
Mark.marksize = 0.015
Mark.draw(x[st..ed], y[st..ed])

st += cnt
ed += cnt
Mark.draw(x[st..ed], y[st..ed], "marktype"=>2)

st += cnt
ed += cnt
Mark.draw(x[st..ed], y[st..ed], "marktype"=>3)

st += cnt
ed += cnt
Mark.draw(x[st..ed], y[st..ed], "marktype"=>4)

Dev.close

