#
# kihonc.rb


require "narray"
require "numru/advanceddcl"
include NumRu::AdvancedDCL
include NMath


#-- graph ---
Dev.open

Frame.new

Fig.window=[0.0, 10.0, 0.0, 10.0]
Fig.viewport=[0.0, 1.0, 0.0, 1.0]
Fig.transnum=1

#-- ftHg ----
y1 = 9.0
for i in 1..8
  x1 = i
  x2 = x1 + 0.1*i
  y2 = y1 + 0.1*i
  Arrow.draw(x1, y1, x2, y2)
end

#-- ̃C^Cv ----
y1 = 8.0
y2 = 8.6
for i in 1..4
  x1 = 2*i - 1
  x2 = x1 + 0.6
  Arrow.draw(x1, y1, x2, y2, "arrowtype"=>i)
end

#-- ̃CCfNX ----
y1 = 7.0
y2 = 7.6
for i in 1..4
  x1 = 2*i
  x2 = x1 + 0.6
  Arrow.draw(x1, y1, x2, y2, "arrowindex"=>i)
end

#-- 蕔̒ ----
Arrow.lprop= false
Arrow.const= 0.03

y1 = 6.0
for i in 1..8
  x1 = i
  x2 = x1 + 0.1*i
  y2 = y1 + 0.1*i
  Arrow.draw(x1, y1, x2, y2)
end

Arrow.lprop= true

#-- 蕔̊px ----
y1 = 5.0
y2 = 5.6
for i in 1..8
  x1 = i
  x2 = x1 + 0.6
  Arrow.draw(x1, y1, x2, y2, "angle"=>10.0*i)
end

#-- 蕔̂ʂԂ ----
Tone.lsoftf=true
Arrow.latone= true
Arrow.iatone= 655

y1 = 4.0
y2 = 4.6
for i in 1..8
  x1 = i
  x2 = x1 + 0.6
  Arrow.draw(x1, y1, x2, y2, "angle"=>10.0*i)
end

#-- CTuv~eBu ----
#-- ftHg ----
Plot.draw([0.0, 10.0], [3.0, 3.0])

#-- ̃CCfNX ----
y1 = 0.5
y2 = 2.5
for i in 1..4
  x1 = 2*i - 1
  x2 = x1 + 2.0
  Plot.draw([x1, x2], [y1, y2], "lineindex"=>i)
end

Dev.close

