# quick1.rb

require "narray"
require "numru/advanceddcl"
include NumRu
include NumRu::AdvancedDCL
include NMath

nmax = 50

x = NArray.sfloat(nmax+1)
y = NArray.sfloat(nmax+1)

#-- data ----
r    = 3.7
x[0] = 0.0
y[0] = 0.5

for n in 0..nmax-1
  x[n+1] = x[n] + 1.0
  y[n+1] = r*y[n]*(1.0-y[n])
end

#-- graph ----
Dev.open("X")
Frame.new

Axis.draw(x,y)
Plot.draw(x,y)

Dev.close
