#
# uxyz4.rb

require "narray"
require "numru/advanceddcl"
include NumRu::AdvancedDCL
include NMath


#-- graph ---
Dev.open

Frame.new

Fig.window=[-50.0, 50.0, 1.0e3, 0.4]
Fig.viewport=[0.2, 0.8, 0.2, 0.8]
Fig.transnum=2

Axis::Lin.xaxdv('B', 5.0, 20.0)
Axis::Lin.xaxdv('T', 5.0, 20.0)
Axis::Lin.xsttl('B', 'LATITUDE (deg)', 0.0)

Axis::Log.iytype= 3
Axis::Log.ydraw('L', 3, 9)
Axis::Log.ydraw('R', 3, 9)
Axis::Lin.ysttl('L', 'PRESSURE (hPa)', 0.0)

Axis::Lin.xmttl('T', 'UXAXDV/ULYLOG', 0.0)

Dev.close

